Comment /* Szinusz tblzat generlsa, szinusz fggvny brzolsa,
           helyfoglals tblzatnak, FPU utastsok, lebegpontos adatok */

Sorhossz = 320

.486                                    ; 486 (FPU is) utastsok engedlyezse

LOCALS

Code16 SEGMENT USE16                    ; .486 dacra is 16-bites szegmens kell

ASSUME CS:Code16, DS:Code16             ; Mem.vltozkhoz DS-t hasznalja TASM!

                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX
                                        ; Szinusz tbla generlsa FPU-val
                MOV     CX,256          ; 256 hossz lesz a tblzatunk
                MOV     SI,OFFSET SINTAB; Szinusz tbla offset cme

                FNINIT                  ; FPU inicializcija
                                        ; FPU verem tartalma:
                FLDPI                   ; PI
                FDIV    CONST128        ; PI/128
                FLDZ                    ; 0  PI/128
@@1:                                    ; Ang  Step
                FLD     ST              ; Ang  Ang  Step
                FSIN                    ; Sin(Ang)  Ang  Step
                FADD    PLUS1           ; Sin(Ang)+1  Ang  Step
                FMUL    AMPL            ; AMPL*(Sin(Ang)+1)  Ang  Step
                FISTP   WORD PTR [SI]   ; Ang  Step
                FADD    ST,ST(1)        ; Ang+Step  Step

                ADD     SI,2            ; Lps a tblzat kvetkez elemre
                LOOP    @@1
                                        ; FPU verem kirtse:
                FSTP    TRASH           ; Step
                FSTP    TRASH           ;
                                        ; Szinusz fgv. kirajzolsa
                MOV     CX,Sorhossz-1   ; Teljes kpszlessgben
@@2:
                MOV     BX,CX           ; Ciklusvltoz adja,hnyadik elem kell
                AND     BX,255          ; Csak 0..255 lehet
                ADD     BX,BX           ; Szorozzuk 2-vel, mert SINTAB WORD-os
                MOV     AX,Sorhossz     ; Kiszmoljuk a kperny pozicit
                MUL     WORD PTR SINTAB[BX]
                ADD     AX,CX           ; Y*Sorhossz + X  (X=ciklusvltoz)
                MOV     DI,AX           ; Fehr pont kigyjtsa adott pozicin
                MOV     BYTE PTR ES:[DI],15
                DEC     CX              ; Ciklusvltoz cskkentse
                JNS     @@2             ; Ha nem negatv, a ciklusmag ismtlse

                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

CONST128        DD      128.0           ; Pi-ig 128 szget trolunk le (SINGLE)
PLUS1           DD      1.0             ; Segd konstans: +1.0 (SINGLE)
AMPL            DD      99.5            ; Szinusz hullm amplitudja (SINGLE)
TRASH           DD      ?               ; "szemetes" mr nem kell adatoknak

SINTAB          DW      256 DUP(?)      ; A szinusz tblzat helye (256db WORD)

Code16 ENDS
END START
