Comment /* Mandelbrot fraktl kirajzolsa */

Sorhossz = 320
.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                MOV     AX,13H
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                FNINIT

                FLD     DELTA0          ; DELTA = DELTA0/XRES
                FDIV    XRES
                FSTP    DELTA

                SUB     DI,DI
                FLD     CI0             ; CI = CI0
                FSTP    CI
@@1:
                MOV     CX,Sorhossz
                FLD     CR00            ; CR = CR00
                FSTP    CR
@@2:
                FLDZ
                FST     I2              ; I2 = 0
                FST     R2              ; R2 = 0
                FST     ZR              ; ZR = 0
                FSTP    ZI              ; ZI = 0
                SUB     BX,BX
@@3:
                FLD     ZR              ; ZI = 2*ZR*ZI+CI
                FADD    ST,ST(0)
                FMUL    ZI
                FADD    CI
                FSTP    ZI

                FLD     R2              ; ZR = R2-I2
                FSUB    I2
                FADD    CR
                FSTP    ZR

                FLD     ZR              ; R2 = ZR*ZR
                FMUL    ZR
                FSTP    R2

                FLD     ZI              ; I2 = ZI*ZI
                FMUL    ZI
                FSTP    I2

                FLD     R2              ; R2+I2 ? 4
                FADD    I2
                FCOMP   CONST4
                FNSTSW  AX
                SAHF
                JAE     @@4

                INC     BX              ; Iterci nvelse
                CMP     BX,MAXITER
                JB      @@3

                MOV     AL,0            ; Max.iterci estn fekete szn
                JMP     @@5
@@4:
                AND     BX,127          ; Normls a sznek szma szerint
                MOV     AL,BL
                ADD     AL,32           ; Kezdszn indexnek hozzadsa
@@5:
                STOSB                   ; Pixel kigyjtsa
                FLD     CR              ; CR = CR+DELTA
                FADD    DELTA
                FSTP    CR

                LOOP    @@2             ; j pixel kvetkezik

                FLD     CI              ; CI = CI+DELTA
                FADD    DELTA
                FSTP    CI

                CMP     DI,Sorhossz*200
                JB      @@1             ; j sor kvetkezik

                MOV     AH,0
                INT     16H
                MOV     AX,3
                INT     10H
                EXITCODE 0

ZI              DQ      0.0             ; Z kpzetes rsze
ZR              DQ      0.0             ; Z vals rsze
CI              DQ      0.0             ; C kpzetes rsze
CR              DQ      0.0             ; C vals rsze
I2              DQ      0.0             ; ZI*ZI
R2              DQ      0.0             ; ZR*ZR
DELTA           DQ      0.0             ; Lptk
CI0             DQ      -2.0            ; C kpzetes rsznek kezdrtkke
CR00            DQ      -2.5            ; C vals rsze kezdrtkke
DELTA0          DQ      6.0             ; C vals rsz ltal bejrt intervallum
XRES            DQ      320.0           ; Pixelek (lpsek) szma X irnyba
CONST4          DQ      4.0             ; Konstans: 4
MAXITER         DW      72              ; Maximlis iterci szma

Code16 ENDS
END START
