Comment /* A msodik ZH megoldsa, a feladatot lsd a ZH2.TXT fjlban */

Sorhossz = 320
SZIN1ST = 1
SINLEN = 2048

RandInit        MACRO                   ;;Vletlenszm init makr fejlce
        LOCAL   _1                      ;;A makr loklis cmkinek felsorolsa

                XOR     AX,AX           ;;Timer szmll lekrdezse
                OUT     43H,AL
                MOV     ES,AX
                IN      AL,40H
                ROR     EAX,8
                IN      AL,40H
                ROR     EAX,8
                MOV     AX,[ES:46CH]    ;;Bekapcsolstol eltelt id lekrdezse
                MOV     SEED,EAX        ;;A szmllk adjk SEED kezdrtkt
                JMP     _1              ;;SEED adat tlpse
        ALIGN 4                         ;;Igazts DWORD hatrra
SEED            DD      ?               ;;A vletlenszmok sornak akt. eleme
_1:
ENDM

RandInt         MACRO                   ;;Linear-congruential Method
                                        ;;      a <- a * b + c mod m
                MOV     EAX,SEED
                MOV     EDX,31415621    ;;recommended constant by Tom Swan
                INC     EAX
                MUL     EDX
                MOV     SEED,EAX
ENDM

RandRange       MACRO   Range           ;;A makr formlis paramtere a Range

                RandInt                 ;;Vletlenszm EAX-be
                MOV     EDX,Range
                SHR     EAX,16          ;;EAX/65536
                MUL     EDX             ;;Range*EAX/65536
                MOV     AX,DX           ;;Range*EAX/65536/65536
                ROR     EAX,16          ;;Vletlenszm EAX-be
ENDM

.486
LOCALS
Code16 SEGMENT USE16
ASSUME CS:Code16, DS:Code16
                ORG 100H
START:
                FNINIT                  ; FPU inicializlsa
                RandInit                ; Vletlenszm genertor inicializlsa

                MOV     AX,13H          ; *** 1. FELADAT ***
                INT     10H
                MOV     AX,0A000H
                MOV     ES,AX

                SUB     DI,DI           ; Kperny feltltse tglalapokkal
                MOV     AL,SZIN1ST
                MOV     CX,200/2
                MOV     BX,Sorhossz
@@1:
                PUSH    CX DI
                MOV     CX,BX
                SUB     CX,Sorhossz-200
@@2:
                PUSH    CX DI
                MOV     CX,BX
                REP     STOSB
                POP     DI CX
                ADD     DI,Sorhossz
                LOOP    @@2
                INC     AX
                SUB     BX,2
                POP     DI CX
                ADD     DI,Sorhossz+1
                LOOP    @@1

                MOV     SI,OFFSET HSIPAL; Sznek eltrolsa
                MOV     DX,3C7H
                MOV     AL,0
                OUT     DX,AL
                ADD     DX,2
                MOV     CX,768
@@3:
                IN      AL,DX
                MOV     [SI],AL
                INC     SI
                LOOP    @@3

                MOV     BX,1            ; Levonand = 0, irny = +1
@@4:
                MOV     DI,63           ; 63 fzisonknt irny csere
@@4B:
                MOV     DX,3DAH
@@5:
                IN      AL,DX
                TEST    AL,8
                JNZ     @@5
@@6:
                IN      AL,DX
                TEST    AL,8
                JZ      @@6

                MOV     SI,OFFSET HSIPAL; Aktulis paletta belltsa
                MOV     DX,3C8H
                MOV     AL,0
                OUT     DX,AL
                INC     DX
                MOV     CX,768
@@7:
                LODSB
                SUB     AL,BH           ; A konponens rtkbl levonunk
                JNS     @@8
                MOV     AL,0            ; Negatv rtk helyett 0
@@8:
                OUT     DX,AL
                LOOP    @@7             ; Kvetkez komponens
                MOV     AH,1
                INT     16H             ; Ha a billentyzet puffer res,
                JNZ     @@9             ; akkor tovbblps a kv. feladatra
                ADD     BH,BL           ; Levonand lptetse
                DEC     DI
                JNZ     @@4B
                NEG     BL              ; Irny vltoztats
                JMP     @@4
@@9:
                MOV     AH,0
                INT     16H             ; A billentyzet puffer kirtse
HEHE1:                                  ; *** 2. FELADAT ***
                MOV     CX,SINLEN       ; X irny szinusz-tblzat generlsa
                MOV     SI,OFFSET XSINTAB
                FLDPI
                FIDIV   COUNT
                FLDZ
@@0:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    RX
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@0
                FSTP    TRASH
                FSTP    TRASH
                MOV     CX,SINLEN       ; Y irny szinusz-tblzat generlsa
                MOV     SI,OFFSET YSINTAB
                FLDPI
                FIDIV   COUNT
                FLDZ
@@1:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    RY
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH

                MOV     CX,Sorhossz*200
                SUB     DI,DI
                MOV     AL,0
                REP     STOSB

                MOV     DX,3C8H         ; A kvnt paletta belltsa
                MOV     AL,0
                OUT     DX,AL
                INC     DX

                MOV     AH,0
                MOV     CX,64           ; Feketbl srga
@@30:
                MOV     AL,AH
                OUT     DX,AL
                OUT     DX,AL
                MOV     AL,0
                OUT     DX,AL
                INC     AH
                LOOP    @@30

                MOV     AH,0
                MOV     CX,64           ; Srgabl fehr
@@31:
                MOV     AL,63
                OUT     DX,AL
                OUT     DX,AL
                MOV     AL,AH
                OUT     DX,AL
                INC     AH
                LOOP    @@31

                MOV     AH,0
                MOV     CX,64           ; Feketbl stt kk
@@32:
                MOV     AL,0
                OUT     DX,AL
                OUT     DX,AL
                MOV     AL,AH
                OUT     DX,AL
                INC     AH
                LOOP    @@32

                MOV     AH,0
                MOV     CX,64           ; Stt kkbl vilgos kk
@@33:
                MOV     AL,0
                OUT     DX,AL
                MOV     AL,AH
                OUT     DX,AL
                MOV     AL,63
                OUT     DX,AL
                INC     AH
                LOOP    @@33

                SUB     BX,BX           ; Kezdfzis = 0
                SUB     SI,SI           ; Kezdfzis = 0 (azonos kezdfzis)
@@4:
                MOV     DX,3DAH         ; Vrakozs kpernyvltsra
@@5:
                IN      AL,DX
                TEST    AL,8
                JNZ     @@5
@@6:
                IN      AL,DX
                TEST    AL,8
                JZ      @@6
                MOV     AX,XSINTAB[BX]  ; Lissajous grbe egyik pontja
                MOV     X1,AX
                MOV     AX,YSINTAB[SI]
                MOV     Y1,AX
                PUSH    BX SI
                ADD     BX,2*SINLEN/2
                ADD     SI,2*SINLEN/2
                AND     BX,2*SINLEN-2
                AND     SI,2*SINLEN-2
                MOV     AX,XSINTAB[BX]  ; Lissajous grbe msik pontja
                MOV     X2,AX
                MOV     AX,YSINTAB[SI]
                MOV     Y2,AX

                IMUL    DI,Y1,Sorhossz
                ADD     DI,X1
                CALL    SPRITEKI
                IMUL    DI,Y2,Sorhossz
                ADD     DI,X2
                CALL    SPRITEKI

                POP     SI BX
                ADD     BX,14
                ADD     SI,16           ; Frekvenciaarny: 7:8
                AND     BX,2*SINLEN-2
                AND     SI,2*SINLEN-2

                MOV     AH,1            ; Ha a billentyzet puffer res,
                INT     16H
                JZ      @@4             ; akkor jhet az jabb fzis rajzolsa

HEHE2:                                  ; *** 3. FELADAT ***
                MOV     CX,SINLEN       ; SINLEN hossz lesz a tblzatunk
                MOV     SI,OFFSET SINTAB
                FLDPI
                FIDIV   COUNT           ; Step = PI/(SINLEN/2)
                FLDZ
@@1:
                FLD     ST
                FSIN
                FADD    PLUS1
                FMUL    AMPL
                FISTP   WORD PTR [SI]
                FADD    ST,ST(1)
                ADD     SI,2
                LOOP    @@1
                FSTP    TRASH
                FSTP    TRASH

                SUB     SI,SI           ; A SI mutat a szinusz rtkekre
                MOV     BX,SINLEN/2     ; A BX mutat a koszinusz rtkekre
                MOV     CX,Sorhossz-1   ; Teljes kpszlessgben
@@2:
                MOV     AX,SINTAB[SI]   ; f(x)=SIN(x)+COS(4x)
                ADD     AX,SINTAB[BX]
                IMUL    DI,AX,Sorhossz
                ADD     DI,CX           ; f(x)*Sorhossz + X  (X=ciklusvltoz)
                MOV     AL,255          ; A 255. szn cyan
                STOSB                   ; Egy pont megjelentse

                ADD     SI,2            ; Szinusz mutatjt lptetjk
                AND     SI,2*SINLEN-2   ; Szinusz mutatjt normljuk
                ADD     BX,8            ; Koszinusz mutatjt lptetjk
                AND     BX,2*SINLEN-2   ; Koszinusz mutatjt normljuk
                DEC     CX              ; Ciklusvltoz cskkentse
                JNS     @@2             ; Ha nem negatv, a ciklusmag ismtlse

                MOV     AH,0            ; A billentyzet puffer kirtse
                INT     16H
                                        ; *** 4. FELADAT ***
                MOV     SI,OFFSET HSIPAL; Paletta kiolvassa (HSIPAL) tmbbe
                MOV     DX,3C7H
                MOV     AL,0
                OUT     DX,AL
                ADD     DX,2
                MOV     CX,768
_1:
                IN      AL,DX
                SHL     AL,2
                MOV     [SI],AL
                INC     SI
                LOOP    _1
                                        ; HSI raw fjl megnyitsa
                MOV     DX,OFFSET HSIFILE
                SUB     CX,CX
                MOV     AH,3CH
                INT     21H
                MOV     BX,AX           ; A fejlc s a paletta fjlba rsa
                MOV     DX,OFFSET HSIHEAD
                MOV     CX,3*256+32
                MOV     AH,40H
                INT     21H
                SUB     DX,DX           ; A kperny tartalmnak fjlba rsa
                PUSH    DS
                MOV     AX,0A000H
                MOV     DS,AX
                MOV     CX,64000
                MOV     AH,40H
                INT     21H
                POP     DS              ; HSI raw fjl lezrsa
                MOV     AH,3EH
                INT     21H

                MOV     BL,0            ; *** 5. FELADAT ***
                SUB     DI,DI
                SUB     AX,AX
                MOV     CX,Sorhossz*200
@@1:
                CMP     ES:[DI],BL
                JE      @@2
                INC     AX
@@2:
                INC     DI
                LOOP    @@1
                MOV     CX,AX
NEXT:
                RandRange 200           ; Vletlenszm: 0 <= y < 200
                IMUL    DI,AX,320       ; Szorozzuk a sor hosszaval
                RandRange 320           ; Vletlenszm: 0 <= x < 320
                ADD     DI,AX           ; DI: y*Sorhossz+x

                CMP     ES:[DI],BL
                JE      NEXT

                MOV     ES:[DI],BL
                LOOP    NEXT

                MOV     AX,3
                INT     10H
                EXITCODE 0

SPRITEKI:       LEA     SI,SPRITE
                MOV     CL,7
@@1:
                MOV     CH,7
@@2:
                LODSB
                ADD     ES:[DI],AL
                INC     DI
                DEC     CH
                JNZ     @@2
                ADD     DI,Sorhossz-7
                LOOP    @@1
                RETN

SPRITE:         DB      0,0,1,1,1,0,0
                DB      0,1,2,2,2,1,0
                DB      1,2,3,4,3,2,1
                DB      1,2,4,5,4,2,1
                DB      1,2,3,4,3,2,1
                DB      0,1,2,2,2,1,0
                DB      0,0,1,1,1,0,0

        ALIGN   16

HSIFILE         DB   'ZH2.RAW',0
HSIHEAD DB 6DH, 68H,77H,61H,6EH,68H,00H,04H,01H,40H,00H,0C8H,01H,00H,00H,00H
        DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
HSIPAL  DB 768 DUP(?)

RX              DD      156.0           ; A grbe x irny sugara
RY              DD      96.0            ; A grbe y irny sugara

COUNT           DD      SINLEN/2        ; Pi-ig SINLEN/2 szget trolunk le
PLUS1           DD      1.0
AMPL            DD      50.0
TRASH           DD      ?

X1              DW      ?
Y1              DW      ?
X2              DW      ?
Y2              DW      ?

XSINTAB         DW      SINLEN DUP(?)
YSINTAB         DW      SINLEN DUP(?)
SINTAB          DW      SINLEN DUP(?)   ; A tblzat helye (SINLEN db WORD)

Code16 ENDS
END START
